VERSION 5.00
Begin VB.Form Form1 
   BackColor       =   &H00800080&
   Caption         =   "Newton's Method-Solving Polynomials  (C) 1986 Science Specialists, Inc."
   ClientHeight    =   3195
   ClientLeft      =   3015
   ClientTop       =   2985
   ClientWidth     =   4680
   FillColor       =   &H00FFFFFF&
   BeginProperty Font 
      Name            =   "Courier New"
      Size            =   12
      Charset         =   0
      Weight          =   400
      Underline       =   0   'False
      Italic          =   0   'False
      Strikethrough   =   0   'False
   EndProperty
   LinkTopic       =   "Form1"
   ScaleHeight     =   3195
   ScaleWidth      =   4680
   WindowState     =   2  'Maximized
   Begin VB.TextBox Text1 
      BeginProperty Font 
         Name            =   "MS Sans Serif"
         Size            =   8.25
         Charset         =   0
         Weight          =   400
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   1695
      Left            =   5400
      MultiLine       =   -1  'True
      TabIndex        =   0
      Text            =   "Poly2.frx":0000
      Top             =   5040
      Visible         =   0   'False
      Width           =   6255
   End
   Begin VB.Menu neq 
      Caption         =   "New Equation"
   End
   Begin VB.Menu nts 
      Caption         =   "Notes"
   End
   Begin VB.Menu clr 
      Caption         =   "Clear"
   End
End
Attribute VB_Name = "Form1"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

Dim flg As Integer, st As String

Dim er, aaaa$, rdm, aa, bb, ew, real, imag, ei, wr1, wr2, d, dd
Dim pi, cr, ci, soq, iter, start, q, ang, sumr, rmdr, sumi, j, sr, sq, n, soi, sor, flag
Dim a(20) As Single, b(20) As Single, s(20) As Single, RF As Single, jazz, cplex, rmd, r


Private Sub clr_Click()
Cls
End Sub

Private Sub Form_Activate()
flg = 1
End Sub

Private Sub Form_Load()
flg = 1
Text1.Text = "This program was developed to help provide a suite of tools for solving simple equations " _
+ "of various types.  Roots with values near 1 and for some repeated roots this " _
+ "method may fail. Original program in BASIC by Science Specialists, Inc. " _
+ " Source code available at www2.fwi.com/~kimble/comp.htm. " _
+ " Remainder is an indication of root suitability.  Several attempts have been " _
+ "used to try to overcome local minima and long valleys when diving the slope.  You may wish " _
+ "to edit these out for a simpler version.(10-5-2000) "
End Sub

Private Sub neq_Click()
flg = 1
Text1.Visible = False
'Form1.Cls
RF = 1
10 GoSub 1000
20 pi = 3.141592653589
30 GoSub 1120
35 'LOCATE 3, 52:
'Print "ITERATION"
40 '************** NEWTON REDUCTION ***************
70 sr = 0.2: cr = 1: ci = 0: flag = 0: start = 1: ' LOCATE 6, 52:
'Print "N"
80 GoSub 170: GoSub 270: soq = sq
90 cr = cr + sr: GoSub 170: GoSub 270: iter = iter + 1
100 If soq < sq Then flag = 0 Else flag = flag + 1
110 If flag = 0 Then If start = 1 Then start = 0 Else GoTo 400
140 sr = sq / ((soq - sq) / sr): If Abs(sq - soq) < 0.000000000001 Then GoTo 260
145 '************** CALCULATE Y  *******************
150 If Abs(sr) < 0.000001 Then GoTo 260
160 soq = sq: GoTo 90
170 sumr = 0: sumi = 0
180 For j = 0 To n
190 r = Sqr(cr ^ 2 + ci ^ 2)
200 If cr = 0 Then If ci > 0 Then ang = pi / 2 Else ang = -pi / 2 Else ang = Atn(ci / cr): If cr < 0 Then ang = ang + pi
210 sumr = a(j) * r ^ j * Cos(ang * j) + sumr
220 sumi = a(j) * r ^ j * Sin(ang * j) + sumi
230 Next j
240 sq = Sqr(sumi ^ 2 + sumr ^ 2): 'LOCATE 4, 50:
'Text2.Text = "": ' LOCATE 4, 50:
'Text2.Text = "Iteration#: " & Format$(iter, "##########  ") & "Evaluation: " & Format$(cr, "##########  ") & ", " & Format$(ci, "##########  ")
250 Return
260 If Abs(sq) > 0.000001 Then GoTo 290 Else GoTo 390
270 sq = Sqr(sumr ^ 2 + sumi ^ 2): If sq < 0.000001 Then GoTo 260 Else Return
280 soq = Sqr(sor ^ 2 + soi ^ 2): Return
285 '************** SEARCH FOR COMPLEX ROOT ********
290 sr = 0.2: ci = 1: iter = 0: start = 1: 'LOCATE 6, 52:
'Print "C"
300 GoSub 170: GoSub 270
310 soq = sq: iter = iter + 1
320 ci = ci + sr: GoSub 170: GoSub 270
330 If soq < sq Then flag = 0 Else flag = flag + 1
340 If flag = 0 Then sr = -sr / 2.0010010001
350 If flag > 2 Then sr = sr * 3.1415926535
360 If (Abs(soq - sq) < 0.00000000001) Then GoTo 390
370 If Abs(sr) < 0.00000001 Then GoTo 390
380 GoTo 310
390 ' LOCATE 6, 52:
 GoSub 1330: GoTo 40
395 '************** NON-NEWTONIAN SEARCH ***********
400 sr = 0.2: flag = 0: iter = 0: sq = 0: soq = 0: 'LOCATE 6, 52:
'Print "R"
410 cr = cr + sr: GoSub 170: iter = iter + 1
420 If soq < sq Then flag = 0 Else flag = flag + 1
430 If flag = 0 Then sr = -sr / 2.1010100001
440 If flag > 3 Then sr = sr * 3.1415926535
450 If (Abs(sq - soq) < 0.00000000001) Then GoTo 500
470 If Abs(sr) < 0.000000001 Then GoTo 260
480 soq = sq: GoTo 410
490 sumr = 0: sumi = 0
500 GoSub 1260: If Abs(rmdr) > 0.000001 Then GoTo 290 Else GoSub 1320: GoTo 70
1000 ' Key OFF
1010  ForeColor = RGB(0, 255, 0)
Cls: Form1.ForeColor = RGB(255, 255, 255)
1020 ' Print "****************************************"
1030 ' Print "*                                      *"
1040 ' Print "* (c) 1986, Science Specialists Inc.   *"
1050 ' Print "*                                      *"
1060 ' Print "*       Polynomial Solving             *"
1070 ' Print "*            Program                   *"
1080 ' Print "*       (Iterative method)             *"
1090 ' Print "*                                      *"
1100 ' Print "****************************************"
1110 ForeColor = (RGB(255, 255, 255)): Return
1120 n = Val(InputBox("ORDER OF POLYNOMIAL"))
If n < 1 Then Exit Sub
1140 For q = n To 0 Step -1
1150 ' Print ""
1160 a(q) = InputBox("INPUT COEFFICIENT FOR S^" & q & "="): Next
1162 'RF = CSRLIN:
st = String$(42, "*"): Print st: st = ""
    For dd = n To 0 Step -1:
    If a(dd) >= 0 Then st = st + "+" & Abs(a(dd)) & "x^" & dd & " " Else st = st + "-" & Abs(a(dd)) & "x^" & dd & " "


 Next

  st = st + "=0 ": Print st
  Print String$(42, "*")
  'print st
If n = 2 Then GoTo 1800
1165 Return
1170 '********** reduce to standard form *********
1180 For q = n - 1 To 0 Step -1
1190 If q > 0 Then a(q) = a(q) / a(n)
1200 Next q: a(n) = 1
1220 s(0) = n - 1
1230 '********** REMAINDER CHECK     *************
1240 '
1250 '
1260  For j = 0 To n: b(j) = a(j): Next: jazz = 1: GoSub 1360: jazz = 0
1270  For j = 0 To n: a(j) = b(j): Next
1280  Return
1290    '
1320  '****************** PRINT OUT ROUTINE ********************
1330  cplex = 0: 'IS THE ROOT COMPLEX
1340  If Abs(ci) > 0.00001 Then cplex = 1: GoTo 1344
1341  GoSub 1260
1343  If Abs(rmdr) > 0.0001 Then cplex = 1 Else cplex = 0
1344  'LOCATE RF, 1:
If cplex = 1 Then GoSub 1430 Else er = cr: Print "REAL ROOT=" & er: RF = RF + 1: GoSub 1360: n = n - 1: GoSub 1400
1345  ci = 0: cr = 0: If n = 2 Then GoTo 1800 Else Return
1346 '
1350 '*** Reduce Equation by division ************
1360 For q = n - 1 To 0 Step -1
1370 a(q) = a(q) + a(q + 1) * cr
1380 Next: rmdr = a(0): rdm = rmdr: If jazz = 0 Then Print "     REMAINDER=" & rdm
If Abs(rdm) > 0.001 Then Print "This method may not be suitable"
1390 For q = 1 To n: a(q - 1) = a(q): Next: Return
1400 If n = 1 Then
'LOCATE RF, 1:
ew = -a(0) / a(1): Print "REAL ROOT=" & ew: RF = RF + 1: GoTo 1700
End If
1410 If n < 1 Then GoTo 1700
1420 Return
1430 '******** extract imaginary roots ***********
1480 real = cr: imag = ci
1490 'LOCATE RF, 1
 er = real: ei = imag: Print "COMPLEX ROOT=" & er & "   +J" & Abs(ei)
1500 Print "COMPLEX ROOT=" & er & "   -J" & Abs(ei): RF = RF + 2
1510 aa = -2 * real: bb = real ^ 2 + imag ^ 2
1520 '******** reduce equation size by division **
1530 For q = n - 1 To 1 Step -1
1540 a(q) = a(q) - a(q + 1) * aa
1550 a(q - 1) = a(q - 1) - a(q + 1) * bb
1560 Next q: a(n) = 1: wr1 = a(1): wr2 = a(0): Print " RMDR=(S*" & wr1 & " " & wr2 & ")"
If (wr1 ^ 2 + wr2 ^ 2) ^ 0.5 > 0.001 Then Print "This method may not be suitable"
1570 n = n - 2: For q = 0 To n: a(q) = a(q + 2): Next
1580 If n = 1 Then
'LOCATE RF, 1:
er = a(0): ei = a(1): Print "REAL ROOT=" & -er / ei: GoTo 1700
End If
1590 If n < 1 Then GoTo 1700
1600 Return
1610 If n = 0 Then GoTo 1700
1700 ForeColor = (RGB(0, 255, 0)): 'LOCATE  1,52:
Exit Sub: ' aaaa$ = InputBox("NEW DATA"): ForeColor = (RGB(255, 255, 255)): If InStr("nNnoNO", aaaa$) = 0 Then GoTo 10
1710 'LOCATE 1, 1:
End
1800 'LOCATE RF, 1
 d = a(1) ^ 2 - 4 * a(2) * a(0)
1900 If d >= 0 Then er = (-a(1) + Sqr(d)) / (2 * a(2)): ei = 0: GoSub 2000: er = (-a(1) - Sqr(d)) / (2 * a(2)): GoSub 2000
1910 If d < 0 Then er = (-a(1)) / (2 * a(2)): ei = Sqr(Abs(d)) / (2 * a(2)): GoSub 2100
1920 GoTo 1700
2000 Print "REAL ROOT=" & er: Return
2100 Print "COMPLEX ROOT=" & er & "   +J" & Abs(ei)
2200 Print "COMPLEX ROOT=" & er & "   -J" & Abs(ei): Return


End Sub

Private Sub nts_Click()
If flg = 1 Then
flg = 0
Text1.Visible = True
nts.Caption = "Close Notes"
Else: flg = 1
Text1.Visible = False
nts.Caption = "Notes"
End If
End Sub
